Botan 1.10.17

Public Member Functions | Protected Member Functions | List of all members
Botan::Zlib_Decompression Class Reference

`#include <zlib.h>`

Inheritance diagram for Botan::Zlib_Decompression:

## Public Member Functions
virtual bool | attachable ()
void | end_msg ()
std::string | name () const
void | start_msg ()
void | write (const byte input[], size_t length)
| Zlib_Decompression ()
| ~Zlib_Decompression ()

## Protected Member Functions
void | send (const byte in[], size_t length)
void | send (byte in)
void | send (const MemoryRegion< byte > &in)
void | send (const MemoryRegion< byte > &in, size_t length)

## Detailed Description

Zlib Decompression Filter

Definition at line 50 of file zlib.h.

## Constructor & Destructor Documentation

## ◆ Zlib_Decompression()

Botan::Zlib_Decompression::Zlib_Decompression | ( |  | ) |

Definition at line 188 of file zlib.cpp.

188 : buffer(DEFAULT_BUFFERSIZE)
189 {
190 zlib = 0;
191 no_writes = true;
192 }

## ◆ ~Zlib_Decompression()

Botan::Zlib_Decompression::~Zlib_Decompression | ( |  | ) |
| inline

Definition at line 60 of file zlib.h.

60 { clear(); }

## Member Function Documentation

## ◆ attachable()

virtual bool Botan::Filter::attachable | ( |  | ) |
| inline virtual inherited

Check whether this filter is an attachable filter.

Returns
  true if this filter is attachable, false otherwise

Reimplemented in Botan::SecureQueue, and Botan::DataSink.

Definition at line 50 of file filter.h.

50 { return true; }

## ◆ end_msg()

void Botan::Zlib_Decompression::end_msg | ( |  | ) |
| virtual

Notify that the current message is finished; flush buffers and do end-of-message processing (if any).

Reimplemented from Botan::Filter.

Definition at line 257 of file zlib.cpp.

References Botan::MemoryRegion< T >::begin(), Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

258 {
259 if(no_writes) return;
260 zlib->stream.next_in = 0;
261 zlib->stream.avail_in = 0;
262
263 int rc = Z_OK;
264
265 while(rc != Z_STREAM_END)
266 {
267 zlib->stream.next_out = reinterpret_cast<Bytef*>(buffer.begin());
268 zlib->stream.avail_out = buffer.size();
269 rc = inflate(&(zlib->stream), Z_SYNC_FLUSH);
270
271 if(rc != Z_OK && rc != Z_STREAM_END)
272 {
273 clear();
274 throw Decoding_Error("Zlib_Decompression: Error finalizing");
275 }
276
277 send(buffer.begin(), buffer.size() - zlib->stream.avail_out);
278 }
279
280 clear();
281 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::MemoryRegion::begin
T * begin()
Definition: secmem.h:59

## ◆ name()

std::string Botan::Zlib_Decompression::name | ( |  | ) | const
| inline virtual

Returns
  descriptive name for this filter

Implements Botan::Filter.

Definition at line 53 of file zlib.h.

53 { return "Zlib_Decompression"; }

## ◆ send() [1/4]

void Botan::Filter::send | ( | const byte | in[],
|  | size_t | length
| ) |  |
| protected inherited

Parameters

  in | some input for the filter
  length | the length of in

Definition at line 28 of file filter.cpp.

References Botan::MemoryRegion< T >::clear(), Botan::MemoryRegion< T >::size(), and Botan::Filter::write().

Referenced by Botan::PK_Encryptor_Filter::end_msg(), Botan::Zlib_Compression::end_msg(), Botan::Bzip_Compression::end_msg(), Botan::Hex_Encoder::end_msg(), Botan::Base64_Encoder::end_msg(), Botan::PK_Decryptor_Filter::end_msg(), Botan::Bzip_Decompression::end_msg(), end_msg(), Botan::PK_Signer_Filter::end_msg(), Botan::Hex_Decoder::end_msg(), Botan::Base64_Decoder::end_msg(), Botan::PK_Verifier_Filter::end_msg(), Botan::Hash_Filter::end_msg(), Botan::MAC_Filter::end_msg(), Botan::Bzip_Compression::flush(), Botan::Zlib_Compression::flush(), Botan::Bzip_Compression::write(), Botan::Zlib_Compression::write(), Botan::StreamCipher_Filter::write(), Botan::Bzip_Decompression::write(), write(), Botan::Hex_Decoder::write(), and Botan::Base64_Decoder::write().

29 {
30 bool nothing_attached = true;
31 for(size_t j = 0; j != total_ports(); ++j)
32 if(next[j])
33 {
34 if(write_queue.size())
35 next[j]->write(&write_queue[0], write_queue.size());
36 next[j]->write(input, length);
37 nothing_attached = false;
38 }
39
40 if(nothing_attached)
41 write_queue += std::make_pair(input, length);
42 else
43 write_queue.clear();
44 }
Botan::Filter::write
virtual void write(const byte input[], size_t length)=0
Botan::MemoryRegion::clear
void clear()
Definition: secmem.h:158
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [2/4]

void Botan::Filter::send | ( | byte | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 63 of file filter.h.

References Botan::Filter::send().

Referenced by Botan::Filter::send().

63 { send(&in, 1); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ send() [3/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in | ) |
| inline protected inherited

Parameters

  in | some input for the filter

Definition at line 68 of file filter.h.

References Botan::Filter::send(), and Botan::MemoryRegion< T >::size().

Referenced by Botan::Filter::send().

68 { send(&in[0], in.size()); }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29

## ◆ send() [4/4]

void Botan::Filter::send | ( | const MemoryRegion< byte > & | in,
|  | size_t | length
| ) |  |
| inline protected inherited

Parameters

  in | some input for the filter
  length | the number of bytes of in to send

Definition at line 74 of file filter.h.

75 {
76 send(&in[0], length);
77 }
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28

## ◆ start_msg()

void Botan::Zlib_Decompression::start_msg | ( |  | ) |
| virtual

Start a new message. Must be closed by end_msg() before another message can be started.

Reimplemented from Botan::Filter.

Definition at line 197 of file zlib.cpp.

Referenced by write().

198 {
199 clear();
200 zlib = new Zlib_Stream;
201 if(inflateInit(&(zlib->stream)) != Z_OK)
202 throw Memory_Exhaustion();
203 }

## ◆ write()

void Botan::Zlib_Decompression::write | ( | const byte | input[],
|  | size_t | length
| ) |  |
| virtual

Write a portion of a message to this filter.

Parameters

  input | the input as a byte array
  length | the length of the byte array input

Implements Botan::Filter.

Definition at line 208 of file zlib.cpp.

References Botan::MemoryRegion< T >::begin(), Botan::Filter::send(), Botan::MemoryRegion< T >::size(), and start_msg().

209 {
210 if(length) no_writes = false;
211
212 // non-const needed by zlib api :(
213 Bytef* input = reinterpret_cast<Bytef*>(const_cast<byte*>(input_arr));
214
215 zlib->stream.next_in = input;
216 zlib->stream.avail_in = length;
217
218 while(zlib->stream.avail_in != 0)
219 {
220 zlib->stream.next_out = reinterpret_cast<Bytef*>(buffer.begin());
221 zlib->stream.avail_out = buffer.size();
222
223 int rc = inflate(&(zlib->stream), Z_SYNC_FLUSH);
224
225 if(rc != Z_OK && rc != Z_STREAM_END)
226 {
227 clear();
228 if(rc == Z_DATA_ERROR)
229 throw Decoding_Error("Zlib_Decompression: Data integrity error");
230 else if(rc == Z_NEED_DICT)
231 throw Decoding_Error("Zlib_Decompression: Need preset dictionary");
232 else if(rc == Z_MEM_ERROR)
233 throw Memory_Exhaustion();
234 else
235 throw std::runtime_error("Zlib decompression: Unknown error");
236 }
237
238 send(buffer.begin(), buffer.size() - zlib->stream.avail_out);
239
240 if(rc == Z_STREAM_END)
241 {
242 size_t read_from_block = length - zlib->stream.avail_in;
243 start_msg();
244
245 zlib->stream.next_in = input + read_from_block;
246 zlib->stream.avail_in = length - read_from_block;
247
248 input += read_from_block;
249 length -= read_from_block;
250 }
251 }
252 }
Botan::byte
unsigned char byte
Definition: types.h:22
Botan::Filter::send
void send(const byte in[], size_t length)
Definition: filter.cpp:28
Botan::MemoryRegion::size
size_t size() const
Definition: secmem.h:29
Botan::Zlib_Decompression::start_msg
void start_msg()
Definition: zlib.cpp:197
Botan::MemoryRegion::begin
T * begin()
Definition: secmem.h:59

The documentation for this class was generated from the following files:

- src/filters/zlib/zlib.h
- src/filters/zlib/zlib.cpp